/// <reference types="node" />
import fs from 'fs';
import { FiniteAutomatonTestInfo, InputStringOption, IOutputFiles } from '../../types';
import { FiniteAutomaton } from '../FiniteAutomaton';
import * as FiniteAutomataTestUtils from './utils';
export interface IAutomataTestConfig {
    automaton: FiniteAutomaton;
    options: InputStringOption;
}
declare type IWriteStreams = Record<`${keyof IOutputFiles}WriteStream`, null | fs.WriteStream>;
export declare class FiniteAutomataTest {
    #private;
    constructor(logsPath: string);
    createFileWriteStreams(automatonLabel: string, outputFiles: Partial<IOutputFiles>): {
        record: {
            caseWriteStream: fs.WriteStream | null;
            incorrectWriteStream: fs.WriteStream | null;
            correctWriteStream: fs.WriteStream | null;
            inputWriteStream: fs.WriteStream | null;
            aggregateWriteStream: fs.WriteStream | null;
            acceptedWriteStream: fs.WriteStream | null;
            rejectedWriteStream: fs.WriteStream | null;
        };
        endStreams(): void;
    };
    testAutomata(finiteAutomaton: FiniteAutomaton, finiteAutomatonTestInfo: FiniteAutomatonTestInfo, writeStreams: IWriteStreams, inputStrings: string[]): void;
    test(configs: {
        automaton: FiniteAutomaton;
        options: InputStringOption;
    }[]): Promise<void>;
}
export { FiniteAutomataTestUtils };
